package flink.zanxiangnet.ad.monitoring.util;

import java.math.BigDecimal;
import java.math.RoundingMode;

public class NumberUtil {

    public static Integer add(Integer val1, Integer val2) {
        if (val1 == null) {
            return val2 == null ? 0 : val2;
        }
        return val2 == null ? val1 : val1 + val2;
    }

    public static Long add(Long val1, Long val2) {
        if (val1 == null) {
            return val2 == null ? 0 : val2;
        }
        return val2 == null ? val1 : val1 + val2;
    }

    public static Double add(Float val1, Float val2) {
        if (val1 == null) {
            return (double) (val2 == null ? 0 : val2);
        }
        return (double) (val2 == null ? val1 : val1 + val2);
    }

    public static Double add(Double val1, Double val2) {
        if (val1 == null) {
            return val2 == null ? 0 : val2;
        }
        return val2 == null ? val1 : val1 + val2;
    }

    public static BigDecimal add(BigDecimal val1, BigDecimal val2) {
        if (val1 == null) {
            return val2 == null ? BigDecimal.ZERO : val2;
        }
        return val2 == null ? val1 : val1.add(val2);
    }

    public static BigDecimal divideForAd(Long val1, Long val2) {
        return divideForAd(val1, val2, 18);
    }

    public static Long divideForMoney(Long val1, Long val2) {
        return divideForAd(val1, val2, 2).longValue();
    }

    public static BigDecimal divideForAd(Long val1, Long val2, int scale) {
        if (val2 == 0 || val1 == 0) {
            return BigDecimal.ZERO;
        }
        return new BigDecimal(val1).divide(new BigDecimal(val2), 18, RoundingMode.HALF_UP);
    }
}
